Index: sasmodels/models/fuzzy_sphere.c
===================================================================
--- sasmodels/models/fuzzy_sphere.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
+++ sasmodels/models/fuzzy_sphere.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -0,0 +1,26 @@
+static double form_volume(double radius, double fuzziness)
+{
+    return M_4PI_3*cube(radius);
+}
+
+static double
+effective_radius(int mode, double radius, double fuzziness)
+{
+    if (mode == 1) {
+        return radius;
+    } else {
+        return radius + fuzziness;
+    }
+}
+
+static void Fq(double q, double *F1, double *F2, double sld, double sld_solvent,
+               double radius, double fuzziness)
+{
+    const double qr = q*radius;
+    const double bes = sas_3j1x_x(qr);
+    const double qf = exp(-0.5*square(q*fuzziness));
+    const double contrast = (sld - sld_solvent);
+    const double form = contrast * form_volume(radius,fuzziness) * bes * qf;
+    *F1 = 1.0e-2*form;
+    *F2 = 1.0e-4*form*form;
+}
Index: sasmodels/models/fuzzy_sphere.py
===================================================================
--- sasmodels/models/fuzzy_sphere.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/fuzzy_sphere.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -78,35 +78,17 @@
               ["sld_solvent", "1e-6/Ang^2",  3, [-inf, inf], "sld",    "Solvent scattering length density"],
               ["radius",      "Ang",        60, [0, inf],    "volume", "Sphere radius"],
-              ["fuzziness",   "Ang",        10, [0, inf],    "",       "std deviation of Gaussian convolution for interface (must be << radius)"],
+              ["fuzziness",   "Ang",        10, [0, inf],    "volume",       "std deviation of Gaussian convolution for interface (must be << radius)"],
              ]
 # pylint: enable=bad-whitespace,line-too-long
 
-source = ["lib/sas_3j1x_x.c"]
+source = ["lib/sas_3j1x_x.c","fuzzy_sphere.c"]
 have_Fq = True
+effective_radius_type = ["radius","radius + fuzziness"]
 
-c_code = """
-static double form_volume(double radius)
-{
-    return M_4PI_3*cube(radius);
-}
-
-static void Fq(double q, double *F1, double *F2, double sld, double sld_solvent,
-               double radius, double fuzziness)
-{
-    const double qr = q*radius;
-    const double bes = sas_3j1x_x(qr);
-    const double qf = exp(-0.5*square(q*fuzziness));
-    const double contrast = (sld - sld_solvent);
-    const double form = contrast * form_volume(radius) * bes * qf;
-    *F1 = 1.0e-2*form;
-    *F2 = 1.0e-4*form*form;
-}
-"""
-
-def ER(radius):
-    """
-    Return radius
-    """
-    return radius
+#def ER(radius):
+#    """
+#    Return radius
+#    """
+#    return radius
 
 # VR defaults to 1.0
Index: sasmodels/models/hollow_cylinder.c
===================================================================
--- sasmodels/models/hollow_cylinder.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/hollow_cylinder.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -22,4 +22,34 @@
 }
 
+static double
+radius_from_volume(double radius, double thickness, double length)
+{
+    const double volume_outer_cyl = M_PI*square(radius + thickness)*length;
+    return cbrt(0.75*volume_outer_cyl/M_PI);
+}
+
+static double
+radius_from_diagonal(double radius, double thickness, double length)
+{
+    return sqrt(square(radius + thickness) + 0.25*square(length));
+}
+
+static double
+effective_radius(int mode, double radius, double thickness, double length)
+{
+    if (mode == 1) {
+        return radius_from_volume(radius, thickness, length);
+    } else if (mode == 2) {
+        return radius + thickness;
+    } else if (mode == 3) {
+        return 0.5*length;
+    } else if (mode == 4) {
+        return (radius + thickness < 0.5*length ? radius + thickness : 0.5*length);
+    } else if (mode == 5) {
+        return (radius + thickness > 0.5*length ? radius + thickness : 0.5*length);
+    } else {
+        return radius_from_diagonal(radius,thickness,length);
+    }
+}
 
 static void
Index: sasmodels/models/hollow_cylinder.py
===================================================================
--- sasmodels/models/hollow_cylinder.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/hollow_cylinder.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -90,23 +90,25 @@
 source = ["lib/polevl.c", "lib/sas_J1.c", "lib/gauss76.c", "hollow_cylinder.c"]
 have_Fq = True
+effective_radius_type = ["equivalent sphere","outer radius","half length",
+                         "half outer min dimension","half outer max dimension","half outer diagonal"]
 
 # pylint: disable=W0613
-def ER(radius, thickness, length):
-    """
-    :param radius:      Cylinder core radius
-    :param thickness:   Cylinder wall thickness
-    :param length:      Cylinder length
-    :return:            Effective radius
-    """
-    router = radius + thickness
-    if router == 0 or length == 0:
-        return 0.0
-    len1 = router
-    len2 = length/2.0
-    term1 = len1*len1*2.0*len2/2.0
-    term2 = 1.0 + (len2/len1)*(1.0 + 1/len2/2.0)*(1.0 + pi*len1/len2/2.0)
-    ddd = 3.0*term1*term2
-    diam = pow(ddd, (1.0/3.0))
-    return diam
+#def ER(radius, thickness, length):
+#    """
+#    :param radius:      Cylinder core radius
+#    :param thickness:   Cylinder wall thickness
+#    :param length:      Cylinder length
+#    :return:            Effective radius
+#    """
+#    router = radius + thickness
+#    if router == 0 or length == 0:
+#        return 0.0
+#    len1 = router
+#    len2 = length/2.0
+#    term1 = len1*len1*2.0*len2/2.0
+#    term2 = 1.0 + (len2/len1)*(1.0 + 1/len2/2.0)*(1.0 + pi*len1/len2/2.0)
+#    ddd = 3.0*term1*term2
+#    diam = pow(ddd, (1.0/3.0))
+#    return diam
 
 def VR(radius, thickness, length):
Index: sasmodels/models/hollow_rectangular_prism.c
===================================================================
--- sasmodels/models/hollow_rectangular_prism.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/hollow_rectangular_prism.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -11,4 +11,24 @@
     double vol_shell = vol_total - vol_core;
     return vol_shell;
+}
+
+static double
+effective_radius(int mode, double length_a, double b2a_ratio, double c2a_ratio, double thickness)
+{
+    if (mode == 1) {
+        return cbrt(0.75*cube(length_a)*b2a_ratio*c2a_ratio/M_PI);
+    } else if (mode == 2) {
+        return 0.5 * length_a;
+    } else if (mode == 3) {
+        return 0.5 * length_a*b2a_ratio;
+    } else if (mode == 4) {
+        return 0.5 * length_a*c2a_ratio;
+    } else if (mode == 5) {
+        return length_a*sqrt(b2a_ratio/M_PI);
+    } else if (mode == 6) {
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio)));
+    } else {
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio) + square(c2a_ratio)));
+    }
 }
 
Index: sasmodels/models/hollow_rectangular_prism.py
===================================================================
--- sasmodels/models/hollow_rectangular_prism.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/hollow_rectangular_prism.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -143,18 +143,20 @@
 source = ["lib/gauss76.c", "hollow_rectangular_prism.c"]
 have_Fq = True
-
-def ER(length_a, b2a_ratio, c2a_ratio, thickness):
-    """
-    Return equivalent radius (ER)
-    thickness parameter not used
-    """
-    b_side = length_a * b2a_ratio
-    c_side = length_a * c2a_ratio
-
-    # surface average radius (rough approximation)
-    surf_rad = sqrt(length_a * b_side / pi)
-
-    ddd = 0.75 * surf_rad * (2 * surf_rad * c_side + (c_side + surf_rad) * (c_side + pi * surf_rad))
-    return 0.5 * (ddd) ** (1. / 3.)
+effective_radius_type = ["equivalent sphere","half length_a", "half length_b", "half length_c",
+                         "equivalent outer circular cross-section","half ab diagonal","half diagonal"]
+
+#def ER(length_a, b2a_ratio, c2a_ratio, thickness):
+#    """
+#    Return equivalent radius (ER)
+#    thickness parameter not used
+#    """
+#    b_side = length_a * b2a_ratio
+#    c_side = length_a * c2a_ratio
+#
+#    # surface average radius (rough approximation)
+#    surf_rad = sqrt(length_a * b_side / pi)
+#
+#    ddd = 0.75 * surf_rad * (2 * surf_rad * c_side + (c_side + surf_rad) * (c_side + pi * surf_rad))
+#    return 0.5 * (ddd) ** (1. / 3.)
 
 def VR(length_a, b2a_ratio, c2a_ratio, thickness):
Index: sasmodels/models/hollow_rectangular_prism_thin_walls.c
===================================================================
--- sasmodels/models/hollow_rectangular_prism_thin_walls.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/hollow_rectangular_prism_thin_walls.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -6,4 +6,24 @@
     double vol_shell = 2.0 * (length_a*length_b + length_a*length_c + length_b*length_c);
     return vol_shell;
+}
+
+static double
+effective_radius(int mode, double length_a, double b2a_ratio, double c2a_ratio)
+{
+    if (mode == 1) {
+        return cbrt(0.75*cube(length_a)*b2a_ratio*c2a_ratio/M_PI);
+    } else if (mode == 2) {
+        return 0.5 * length_a;
+    } else if (mode == 3) {
+        return 0.5 * length_a*b2a_ratio;
+    } else if (mode == 4) {
+        return 0.5 * length_a*c2a_ratio;
+    } else if (mode == 5) {
+        return length_a*sqrt(b2a_ratio/M_PI);
+    } else if (mode == 6) {
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio)));
+    } else {
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio) + square(c2a_ratio)));
+    }
 }
 
Index: sasmodels/models/hollow_rectangular_prism_thin_walls.py
===================================================================
--- sasmodels/models/hollow_rectangular_prism_thin_walls.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/hollow_rectangular_prism_thin_walls.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -103,17 +103,19 @@
 source = ["lib/gauss76.c", "hollow_rectangular_prism_thin_walls.c"]
 have_Fq = True
+effective_radius_type = ["equivalent sphere","half length_a", "half length_b", "half length_c",
+                         "equivalent outer circular cross-section","half ab diagonal","half diagonal"]
 
-def ER(length_a, b2a_ratio, c2a_ratio):
-    """
-        Return equivalent radius (ER)
-    """
-    b_side = length_a * b2a_ratio
-    c_side = length_a * c2a_ratio
-
-    # surface average radius (rough approximation)
-    surf_rad = sqrt(length_a * b_side / pi)
-
-    ddd = 0.75 * surf_rad * (2 * surf_rad * c_side + (c_side + surf_rad) * (c_side + pi * surf_rad))
-    return 0.5 * (ddd) ** (1. / 3.)
+#def ER(length_a, b2a_ratio, c2a_ratio):
+#    """
+#        Return equivalent radius (ER)
+#    """
+#    b_side = length_a * b2a_ratio
+#    c_side = length_a * c2a_ratio
+#
+#    # surface average radius (rough approximation)
+#    surf_rad = sqrt(length_a * b_side / pi)
+#
+#    ddd = 0.75 * surf_rad * (2 * surf_rad * c_side + (c_side + surf_rad) * (c_side + pi * surf_rad))
+#    return 0.5 * (ddd) ** (1. / 3.)
 
 def VR(length_a, b2a_ratio, c2a_ratio):
Index: sasmodels/models/mono_gauss_coil.c
===================================================================
--- sasmodels/models/mono_gauss_coil.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
+++ sasmodels/models/mono_gauss_coil.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -0,0 +1,31 @@
+static double form_volume(double rg)
+{
+    return 1.0;
+}
+
+static double
+effective_radius(int mode, double rg)
+{
+    if (mode == 1) {
+        return rg;
+    } else if (mode == 2) {
+        return 2.0*rg;
+    } else if (mode == 3) {
+        return 3.0*rg;
+    } else {
+        return sqrt(5.0/3.0)*rg;
+    }
+}
+
+double Iq(double q, double i_zero, double rg)
+{
+    const double uarg = square(q*rg);
+    const double inten;
+    if (q == 0) {
+        inten = i_zero;
+    } else {
+        inten = 2.0*i_zero * (exp(-uarg) + uarg - 1.0)/square(uarg);
+    }
+
+    return inten;
+}
Index: sasmodels/models/mono_gauss_coil.py
===================================================================
--- sasmodels/models/mono_gauss_coil.py	(revision 2d81cfe3be42579d563407fb9275b7b516fee234)
+++ sasmodels/models/mono_gauss_coil.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -54,5 +54,5 @@
 
 import numpy as np
-from numpy import inf, exp, errstate
+from numpy import inf
 
 name = "mono_gauss_coil"
@@ -69,18 +69,24 @@
 parameters = [
     ["i_zero", "1/cm", 70.0, [0.0, inf], "", "Intensity at q=0"],
-    ["rg", "Ang", 75.0, [0.0, inf], "", "Radius of gyration"],
+    ["rg", "Ang", 75.0, [0.0, inf], "volume", "Radius of gyration"],
     ]
+
+source = ["mono_gauss_coil.c"]
+have_Fq = False
+effective_radius_type = ["R_g","2R_g","3R_g","(5/3)^0.5*R_g"]
+
+
 # pylint: enable=bad-whitespace, line-too-long
 
-# NB: Scale and Background are implicit parameters on every model
-def Iq(q, i_zero, rg):
-    # pylint: disable = missing-docstring
-    z = (q * rg)**2
-
-    with errstate(invalid='ignore'):
-        inten = (i_zero * 2.0) * (exp(-z) + z - 1.0)/z**2
-        inten[q == 0] = i_zero
-    return inten
-Iq.vectorized = True # Iq accepts an array of q values
+## NB: Scale and Background are implicit parameters on every model
+#def Iq(q, i_zero, rg):
+#    # pylint: disable = missing-docstring
+#    z = (q * rg)**2
+#
+#    with errstate(invalid='ignore'):
+#        inten = (i_zero * 2.0) * (exp(-z) + z - 1.0)/z**2
+#        inten[q == 0] = i_zero
+#    return inten
+#Iq.vectorized = True # Iq accepts an array of q values
 
 def random():
Index: sasmodels/models/multilayer_vesicle.c
===================================================================
--- sasmodels/models/multilayer_vesicle.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/multilayer_vesicle.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -47,4 +47,10 @@
 }
 
+static double
+effective_radius(int mode, double radius, double thick_shell, double thick_solvent, double fp_n_shells)
+{
+    return radius + fp_n_shells*thick_shell + (fp_n_shells - 1.0)*thick_solvent;
+}
+
 static void
 Fq(double q,
Index: sasmodels/models/multilayer_vesicle.py
===================================================================
--- sasmodels/models/multilayer_vesicle.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/multilayer_vesicle.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -146,8 +146,9 @@
 source = ["lib/sas_3j1x_x.c", "multilayer_vesicle.c"]
 have_Fq = True
+effective_radius_type = ["outer radius"]
 
-def ER(radius, thick_shell, thick_solvent, n_shells):
-    n_shells = int(n_shells+0.5)
-    return radius + n_shells * (thick_shell + thick_solvent) - thick_solvent
+#def ER(radius, thick_shell, thick_solvent, n_shells):
+#    n_shells = int(n_shells+0.5)
+#    return radius + n_shells * (thick_shell + thick_solvent) - thick_solvent
 
 def random():
Index: sasmodels/models/onion.c
===================================================================
--- sasmodels/models/onion.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/onion.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -40,4 +40,15 @@
 }
 
+static double
+effective_radius(int mode, double radius_core, double n_shells, double thickness[])
+{
+  int n = (int)(n_shells+0.5);
+  double r = radius_core;
+  for (int i=0; i < n; i++) {
+    r += thickness[i];
+  }
+  return r;
+}
+
 static void
 Fq(double q, double *F1, double *F2, double sld_core, double radius_core, double sld_solvent,
Index: sasmodels/models/onion.py
===================================================================
--- sasmodels/models/onion.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/onion.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -316,4 +316,5 @@
 single = False
 have_Fq = True
+effective_radius_type = ["outer radius"]
 
 profile_axes = ['Radius (A)', 'SLD (1e-6/A^2)']
@@ -366,8 +367,8 @@
     return np.asarray(z), np.asarray(rho)
 
-def ER(radius_core, n_shells, thickness):
-    """Effective radius"""
-    n = int(n_shells[0]+0.5)
-    return np.sum(thickness[:n], axis=0) + radius_core
+#def ER(radius_core, n_shells, thickness):
+#    """Effective radius"""
+#    n = int(n_shells[0]+0.5)
+#    return np.sum(thickness[:n], axis=0) + radius_core
 
 demo = {
Index: sasmodels/models/parallelepiped.c
===================================================================
--- sasmodels/models/parallelepiped.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/parallelepiped.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -3,4 +3,24 @@
 {
     return length_a * length_b * length_c;
+}
+
+static double
+effective_radius(int mode, double length_a, double length_b, double length_c)
+{
+    if (mode == 1) {
+        return cbrt(0.75*length_a*length_b*length_c/M_PI);
+    } else if (mode == 2) {
+        return 0.5 * length_a;
+    } else if (mode == 3) {
+        return 0.5 * length_b;
+    } else if (mode == 4) {
+        return 0.5 * length_c;
+    } else if (mode == 5) {
+        return sqrt(length_a*length_b/M_PI);
+    } else if (mode == 6) {
+        return 0.5*sqrt(length_a*length_a + length_b*length_b);
+    } else {
+        return 0.5*sqrt(length_a*length_a + length_b*length_b + length_c*length_c);
+    }
 }
 
Index: sasmodels/models/parallelepiped.py
===================================================================
--- sasmodels/models/parallelepiped.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/parallelepiped.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -231,20 +231,22 @@
 source = ["lib/gauss76.c", "parallelepiped.c"]
 have_Fq = True
-
-def ER(length_a, length_b, length_c):
-    """
-    Return effective radius (ER) for P(q)*S(q)
-    """
-    # now that axes can be in any size order, need to sort a,b,c
-    # where a~b and c is either much smaller or much larger
-    abc = np.vstack((length_a, length_b, length_c))
-    abc = np.sort(abc, axis=0)
-    selector = (abc[1] - abc[0]) > (abc[2] - abc[1])
-    length = np.where(selector, abc[0], abc[2])
-    # surface average radius (rough approximation)
-    radius = sqrt(np.where(~selector, abc[0]*abc[1], abc[1]*abc[2]) / pi)
-
-    ddd = 0.75 * radius * (2*radius*length + (length + radius)*(length + pi*radius))
-    return 0.5 * (ddd) ** (1. / 3.)
+effective_radius_type = ["equivalent sphere","half length_a", "half length_b", "half length_c",
+                         "equivalent circular cross-section","half ab diagonal","half diagonal"]
+
+#def ER(length_a, length_b, length_c):
+#    """
+#    Return effective radius (ER) for P(q)*S(q)
+#    """
+#    # now that axes can be in any size order, need to sort a,b,c
+#    # where a~b and c is either much smaller or much larger
+#    abc = np.vstack((length_a, length_b, length_c))
+#    abc = np.sort(abc, axis=0)
+#    selector = (abc[1] - abc[0]) > (abc[2] - abc[1])
+#    length = np.where(selector, abc[0], abc[2])
+#    # surface average radius (rough approximation)
+#    radius = sqrt(np.where(~selector, abc[0]*abc[1], abc[1]*abc[2]) / pi)
+#
+#    ddd = 0.75 * radius * (2*radius*length + (length + radius)*(length + pi*radius))
+#    return 0.5 * (ddd) ** (1. / 3.)
 
 # VR defaults to 1.0
Index: sasmodels/models/pringle.c
===================================================================
--- sasmodels/models/pringle.c	(revision 74768cb764a04223ec9e992e316cb8c211adfe34)
+++ sasmodels/models/pringle.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -104,4 +104,14 @@
 }
 
+static double
+effective_radius(int mode, double radius, double thickness, double alpha, double beta)
+{
+    if (mode == 1) {
+        return cbrt(0.75*radius*radius*thickness);
+    } else {
+        return radius;
+    }
+}
+
 double Iq(
     double q,
Index: sasmodels/models/pringle.py
===================================================================
--- sasmodels/models/pringle.py	(revision ef07e950965796e2a3a8156fcade98ce5e403001)
+++ sasmodels/models/pringle.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -74,12 +74,13 @@
 source = ["lib/polevl.c", "lib/sas_J0.c", "lib/sas_J1.c", \
           "lib/sas_JN.c", "lib/gauss76.c", "pringle.c"]
+effective_radius_type = ["equivalent sphere","radius"]
 
-def ER(radius, thickness, alpha, beta):
-    """
-    Return equivalent radius (ER)
-    """
-    ddd = 0.75 * radius * (2 * radius * thickness + (thickness + radius) \
-                           * (thickness + pi * radius))
-    return 0.5 * (ddd) ** (1. / 3.)
+#def ER(radius, thickness, alpha, beta):
+#    """
+#    Return equivalent radius (ER)
+#    """
+#    ddd = 0.75 * radius * (2 * radius * thickness + (thickness + radius) \
+#                           * (thickness + pi * radius))
+#    return 0.5 * (ddd) ** (1. / 3.)
 
 def random():
Index: sasmodels/models/raspberry.c
===================================================================
--- sasmodels/models/raspberry.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/raspberry.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -1,3 +1,3 @@
-double form_volume(double radius_lg);
+double form_volume(double radius_lg, double radius_sm, double penetration);
 
 double Iq(double q,
@@ -6,5 +6,5 @@
           double radius_lg, double radius_sm, double penetration);
 
-double form_volume(double radius_lg)
+double form_volume(double radius_lg, double radius_sm, double penetration)
 {
     //Because of the complex structure, volume normalization must
@@ -12,4 +12,14 @@
     double volume=1.0;
     return volume;
+}
+
+static double
+effective_radius(int mode, double radius_lg, double radius_sm, double penetration)
+{
+    if (mode == 1) {
+        return radius_lg;
+    } else {
+        return radius_lg + 2.0*radius_sm - penetration;
+    }
 }
 
Index: sasmodels/models/raspberry.py
===================================================================
--- sasmodels/models/raspberry.py	(revision ef07e950965796e2a3a8156fcade98ce5e403001)
+++ sasmodels/models/raspberry.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -145,11 +145,12 @@
               ["radius_lg", "Ang", 5000, [0, inf], "volume",
                "radius of large spheres"],
-              ["radius_sm", "Ang", 100, [0, inf], "",
+              ["radius_sm", "Ang", 100, [0, inf], "volume",
                "radius of small spheres"],
-              ["penetration", "Ang", 0, [-1, 1], "",
+              ["penetration", "Ang", 0, [-1, 1], "volume",
                "fractional penetration depth of small spheres into large sphere"],
              ]
 
 source = ["lib/sas_3j1x_x.c", "raspberry.c"]
+effective_radius_type = ["radius_large","radius_outer"]
 
 def random():
Index: sasmodels/models/rectangular_prism.c
===================================================================
--- sasmodels/models/rectangular_prism.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/rectangular_prism.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -3,4 +3,24 @@
 {
     return length_a * (length_a*b2a_ratio) * (length_a*c2a_ratio);
+}
+
+static double
+effective_radius(int mode, double length_a, double b2a_ratio, double c2a_ratio)
+{
+    if (mode == 1) {
+        return cbrt(0.75*cube(length_a)*b2a_ratio*c2a_ratio/M_PI);
+    } else if (mode == 2) {
+        return 0.5 * length_a;
+    } else if (mode == 3) {
+        return 0.5 * length_a*b2a_ratio;
+    } else if (mode == 4) {
+        return 0.5 * length_a*c2a_ratio;
+    } else if (mode == 5) {
+        return length_a*sqrt(b2a_ratio/M_PI);
+    } else if (mode == 6) {
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio)));
+    } else {
+        return 0.5*sqrt(square(length_a) * (1.0 + square(b2a_ratio) + square(c2a_ratio)));
+    }
 }
 
Index: sasmodels/models/rectangular_prism.py
===================================================================
--- sasmodels/models/rectangular_prism.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/rectangular_prism.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -136,17 +136,19 @@
 source = ["lib/gauss76.c", "rectangular_prism.c"]
 have_Fq = True
+effective_radius_type = ["equivalent sphere","half length_a", "half length_b", "half length_c",
+                         "equivalent circular cross-section","half ab diagonal","half diagonal"]
 
-def ER(length_a, b2a_ratio, c2a_ratio):
-    """
-        Return equivalent radius (ER)
-    """
-    b_side = length_a * b2a_ratio
-    c_side = length_a * c2a_ratio
-
-    # surface average radius (rough approximation)
-    surf_rad = sqrt(length_a * b_side / pi)
-
-    ddd = 0.75 * surf_rad * (2 * surf_rad * c_side + (c_side + surf_rad) * (c_side + pi * surf_rad))
-    return 0.5 * (ddd) ** (1. / 3.)
+#def ER(length_a, b2a_ratio, c2a_ratio):
+#    """
+#        Return equivalent radius (ER)
+#    """
+#    b_side = length_a * b2a_ratio
+#    c_side = length_a * c2a_ratio
+#
+#    # surface average radius (rough approximation)
+#    surf_rad = sqrt(length_a * b_side / pi)
+#
+#    ddd = 0.75 * surf_rad * (2 * surf_rad * c_side + (c_side + surf_rad) * (c_side + pi * surf_rad))
+#    return 0.5 * (ddd) ** (1. / 3.)
 
 def random():
Index: sasmodels/models/sphere.c
===================================================================
--- sasmodels/models/sphere.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
+++ sasmodels/models/sphere.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -0,0 +1,19 @@
+static double form_volume(double radius)
+{
+    return M_4PI_3*cube(radius);
+}
+
+static double
+effective_radius(int mode, double radius)
+{
+    return radius;
+}
+
+static void Fq(double q, double *f1, double *f2, double sld, double sld_solvent, double radius)
+{
+    const double bes = sas_3j1x_x(q*radius);
+    const double contrast = (sld - sld_solvent);
+    const double form = contrast * form_volume(radius) * bes;
+    *f1 = 1.0e-2*form;
+    *f2 = 1.0e-4*form*form;
+}
Index: sasmodels/models/sphere.py
===================================================================
--- sasmodels/models/sphere.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/sphere.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -67,28 +67,13 @@
              ]
 
-source = ["lib/sas_3j1x_x.c"]
+source = ["lib/sas_3j1x_x.c","sphere.c"]
 have_Fq = True
+effective_radius_type = ["radius"]
 
-c_code = """
-static double form_volume(double radius)
-{
-    return M_4PI_3*cube(radius);
-}
-
-static void Fq(double q, double *f1, double *f2, double sld, double sld_solvent, double radius)
-{
-    const double bes = sas_3j1x_x(q*radius);
-    const double contrast = (sld - sld_solvent);
-    const double form = contrast * form_volume(radius) * bes;
-    *f1 = 1.0e-2*form;
-    *f2 = 1.0e-4*form*form;
-}
-"""
-
-def ER(radius):
-    """
-    Return equivalent radius (ER)
-    """
-    return radius
+#def ER(radius):
+#    """
+#    Return equivalent radius (ER)
+#    """
+#    return radius
 
 # VR defaults to 1.0
Index: sasmodels/models/spherical_sld.c
===================================================================
--- sasmodels/models/spherical_sld.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/spherical_sld.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -10,4 +10,15 @@
     }
     return M_4PI_3*cube(r);
+}
+
+static double
+effective_radius(int mode, double fp_n_shells, double thickness[], double interface[])
+{
+    int n_shells= (int)(fp_n_shells + 0.5);
+    double r = 0.0;
+    for (int i=0; i < n_shells; i++) {
+        r += thickness[i] + interface[i];
+    }
+    return r;
 }
 
Index: sasmodels/models/spherical_sld.py
===================================================================
--- sasmodels/models/spherical_sld.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/spherical_sld.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -210,4 +210,5 @@
 single = False  # TODO: fix low q behaviour
 have_Fq = True
+effective_radius_type = ["outer radius"]
 
 profile_axes = ['Radius (A)', 'SLD (1e-6/A^2)']
@@ -255,10 +256,10 @@
 
 
-def ER(n_shells, thickness, interface):
-    """Effective radius"""
-    n_shells = int(n_shells + 0.5)
-    total = (np.sum(thickness[:n_shells], axis=1)
-             + np.sum(interface[:n_shells], axis=1))
-    return total
+#def ER(n_shells, thickness, interface):
+#    """Effective radius"""
+#    n_shells = int(n_shells + 0.5)
+#    total = (np.sum(thickness[:n_shells], axis=1)
+#             + np.sum(interface[:n_shells], axis=1))
+#    return total
 
 
Index: sasmodels/models/triaxial_ellipsoid.c
===================================================================
--- sasmodels/models/triaxial_ellipsoid.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/triaxial_ellipsoid.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -7,4 +7,35 @@
 }
 
+static double
+radius_from_volume(double radius_equat_minor, double radius_equat_major, double radius_polar)
+{
+    return cbrt(radius_equat_minor*radius_equat_major*radius_polar);
+}
+
+static double
+radius_from_min_dimension(double radius_equat_minor, double radius_equat_major, double radius_polar)
+{
+    const double rad_equat_min = (radius_equat_minor < radius_equat_major ? radius_equat_minor : radius_equat_major);
+    return (rad_equat_min < radius_polar ? rad_equat_min : radius_polar);
+}
+
+static double
+radius_from_max_dimension(double radius_equat_minor, double radius_equat_major, double radius_polar)
+{
+    const double rad_equat_max = (radius_equat_minor < radius_equat_major ? radius_equat_major : radius_equat_minor);
+    return (rad_equat_max > radius_polar ? rad_equat_max : radius_polar);
+}
+
+static double
+effective_radius(int mode, double radius_equat_minor, double radius_equat_major, double radius_polar)
+{
+    if (mode == 1) {
+        return radius_from_volume(radius_equat_minor,radius_equat_major, radius_polar);
+    } else if (mode == 2) {
+        return radius_from_min_dimension(radius_equat_minor,radius_equat_major, radius_polar);
+    } else {
+        return radius_from_max_dimension(radius_equat_minor,radius_equat_major, radius_polar);
+    }
+}
 
 static void
Index: sasmodels/models/triaxial_ellipsoid.py
===================================================================
--- sasmodels/models/triaxial_ellipsoid.py	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/triaxial_ellipsoid.py	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -158,4 +158,5 @@
 source = ["lib/sas_3j1x_x.c", "lib/gauss76.c", "triaxial_ellipsoid.c"]
 have_Fq = True
+effective_radius_type = ["equivalent sphere","min radius", "max radius"]
 
 def ER(radius_equat_minor, radius_equat_major, radius_polar):
Index: sasmodels/models/vesicle.c
===================================================================
--- sasmodels/models/vesicle.c	(revision 71b751d6a3a4ef4164f3b322841ddf3875c025c5)
+++ sasmodels/models/vesicle.c	(revision d277229f02cb7770fbb4ea2ad506d96bed705d75)
@@ -6,4 +6,9 @@
 }
 
+static double
+effective_radius(int mode, double radius, double thickness)
+{
+    return radius + thickness;
+}
 
 static void
